Summary:   Python LDAP-client running as a CGI-BIN or in standalone mode
Name:      web2ldap
Version:   0.7.5
Release:   11
URL:       http://www.web2ldap.de/
Source0:   http://www.web2ldap.de/download/%{name}-%{version}.tar.gz
Source1:   http://www.webideal.de/ldap/web2ldap.init
Source2:   http://www.webideal.de/ldap/web2ldap.logrotate
Patch0:    http://www.webideal.de/ldap/web2ldap.patch
Copyright: GPL 
Group:     Applications/Networking
Vendor:    webIdeal (http://www.webideal.de)
Provides:  web2ldap
Conflicts: ldap-client-cgi
Requires:  python >= 1.5 ldapmodule
BuildArchitectures: noarch
BuildRoot: /tmp/%{name}-%{version}-root
Packager: Mirko Zeibig <mz@webideal.de>

# Definitions for different distr. and apaches
# Test for different apache locations
%define RedHA %(test -d /home/httpd && echo 1 || echo 0)
%define SUSEA %(test -d /usr/local/httpd && echo 1 || echo 0)
%define IBMA  %(test -d /opt/IBMHTTPServer && echo 1 || echo 0)
# Test for location of init.d
%define INITD %(test -d /sbin/init.d && echo /sbin/init.d || echo /etc/rc.d/init.d)

# Is logrotate installed?
%define LOGROTATE %(test -f /etc/logrotate.conf && echo 1 || echo 0)

%description
web2ldap.py (formerly known as ldap-client-cgi.py)
this is a full-featured LDAP client written in Python designed to run
as an CGI-BIN under the control of a WWW server but may run in standalone
mode as well. 
Just rebuild the SRPM for SuSE, RedHat or IBMHTTPServer support!
With older versions of glibc (=<2.1.12-12) on RedHat make sure to take
the GET-Method for standalone mode!
The old URL is: http://sites.inka.de/ms/python/web2ldap/
Author: Michael Stroeder <michael.stroder@inka.de>

%prep        

%setup -q
%patch -p0

%build

%install
rm -rf $RPM_BUILD_ROOT
# cgi-bin and standaline
mkdir -p $RPM_BUILD_ROOT/usr/lib/web2ldap/{pylib,html}
mkdir -p $RPM_BUILD_ROOT{/etc/web2ldap,/var/log/web2ldap,/usr/sbin}
mkdir -p $RPM_BUILD_ROOT%{INITD}
install -m755 $RPM_SOURCE_DIR/web2ldap.init $RPM_BUILD_ROOT%{INITD}/web2ldap

install -m755 pylib/* $RPM_BUILD_ROOT/usr/lib/web2ldap/pylib/
install -m755 cgi-bin/web2ldap.py $RPM_BUILD_ROOT/usr/sbin/
install -m644 cgi-bin/web2ldapcnf.py $RPM_BUILD_ROOT/etc/web2ldap/
#install -m644 css/* $RPM_BUILD_ROOT/usr/lib/web2ldap/
install -m644 templates/* $RPM_BUILD_ROOT/usr/lib/web2ldap/html/
install -m755 sbin/* $RPM_BUILD_ROOT/usr/sbin/
# only for cgi-bin
%if %RedHA
CGIROOT=/home/httpd/cgi-bin
%endif
%if %SUSEA
CGIROOT=/usr/local/httpd/cgi-bin
%endif
%if %IBMA
CGIROOT=/opt/IBMHTTPServer/cgi-bin
%endif
mkdir -p $RPM_BUILD_ROOT$CGIROOT
install -m755 cgi-bin/web2ldap.py $RPM_BUILD_ROOT$CGIROOT/

%if %{LOGROTATE}
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/web2ldap.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/web2ldap
%endif

# compile libraries
/usr/bin/python /usr/lib/python1.5/compileall.py ${RPM_BUILD_ROOT}/

%clean
rm -rf $RPM_BUILD_ROOT

%post
# try to create a ldapoc.py-file
# get all included oc.conf-files in /etc/openldap/slapd.conf
#
[ -f /etc/openldap/slapd.conf ] && {
    echo "Trying to create ldapoc.py"
    cat $(/bin/awk '$1~/^include$/&&$2~/.oc.conf$/{print $2}' /etc/openldap/slapd.conf) | \
    /usr/sbin/occonf2ldapoc.py > /usr/lib/web2ldap/pylib/ldapoc.py
}
echo "Compiling ldapoc ..."
/usr/bin/python -c 'import py_compile; py_compile.compile("/usr/lib/web2ldap/pylib/ldapoc.py")'
/usr/bin/python -c 'import py_compile; py_compile.compile("/etc/web2ldap/web2ldapcnf.py")'

mail -s "web2ldap install" root <<EOF
Make sure you read the documentation and alter
/etc/web2ldapcnf.py to your needs.
Also take a look at /usr/sbin/occonf2ldapoc.py, which
will create /usr/lib/web2ldap/pylib/ldapoc.py
out of standard-input (typically /etc/openldap/slapd.oc.conf, 
you may include your own extentions by providing seperate .oc.conf
files and insert an include-line in /etc/openldap/slapd.conf.
EOF

%files
%defattr(-,root,root)
%doc contrib htdocs/
%config /etc/web2ldap/web2ldapcnf.py
/etc/web2ldap/web2ldapcnf.pyc
/usr/lib/web2ldap/
/usr/sbin/*
%if %RedHA
/home/httpd/cgi-bin/web2ldap.py*
%endif
%if %SUSEA
/usr/local/httpd/cgi-bin/web2ldap.py*
%endif
%if %IBMA
/opt/IBMHTTPServer/cgi-bin/*
%endif
%{INITD}/*
%if %{LOGROTATE}
/etc/logrotate.d/*
%endif
%defattr(-,nobody,nobody)
/var/log/web2ldap

%changelog
* Thu Apr 27 2000 <mz@webideal.de>
- SuSE and IBMHTTPServer support when rebuilding the SRPM, so I dropped the
  RPM
- Apache support is not necessary anymore, so I made this a choice during
  build
- With older versions of glibc (=<2.1.12-12) on RedHat make sure to take
  the GET-Method for standalone mode!
* Wed Apr 21 2000 <mz@webideal.de>
- lot's of changes due to the fact that web2ldap can be run as standalone as well
  - removed dependency for Apache
  - rc-startup-script for standalone-mode (on SuSE you have to do the links
    yourself, on RH just enter "chkconfig --add web2ldap")
  - logrotate-script for standalone-mode
  - all web2ldap-libs goto /usr/lib/web2ldap/pylib
  - standalone web2ldap.py goes to /usr/sbin
  - configuration file(s) now in /etc/web2ldap
  - removed css temporarily as I found no possibility to get this
    working for standalone and cgi-bin mode
- note for standalone-mode:
  - If using "POST", I had serious problems running w2l in standalone mode, 
    netscape  complaining about a network error, lynx and w3m will do +-
  - so try "GET" when using standalone-mode!!
* Wed Apr 05 2000 <mz@webideal.de>
- as in every release Michael changed the location of the files a bit ;-),
  so some changes in the install procedure had to be done.
* Mon Feb 21 2000 <mz@webideal.de>
- new release, lot's of changes (see changes.html)
* Tue Feb 08 2000 <mz@webideal.de>
- finally Michael did include some documentation :-)
* Thu Jan 27 2000 <mz@webideal.de>
- some new stuff, just packed it into /home/httpd/html/web2ldap
- adapted to my own site 
* Thu Jan 06 2000 <mz@webideal.de>
- new version with a few fixes
- try to import all oc.conf-files in post-install
* Tue Jan 04 2000 <mz@webideal.de>
- Changes since 0.5.8: enhanced user interface
* Sun Jan 01 2000 <mz@webideal.de>
- version 0.58
* Tue Dec 14 1999 <mz@webideal.de>
- Michael found another bug, so ...
* Mon Dec 13 1999 <mz@webideal.de>
- Michael forgot to correct one bug and has a new webpage. 
* Mon Dec 13 1999 <mz@webideal.de>
- new package 0.5.3
* Fri Nov 19 1999 <mz@webideal.de>
- Michael changed the name of the whole package, so ...
  I had to change the scripts and inserted the Conflicts-Tag
- minor improvements of the build-script
* Thu Sep 23 1999 <mz@webideal.de>
- updated spec-file for 0.5.0pre4
- you better make oc-changes to /etc/openldap/slapd.oc.conf as
  ldapoc.py is created automatically by /usr/sbin/occonf2ldapoc.py
* Mon Sep 08 1999 <mz@webideal.de>
- Author now mentioned in the description-tag
* Mon Sep 07 1999 <mz@webideal.de>
- fits into Redhat-directory-scheme

